use self::parser_context::Context;
use crate::error::Res;
use crate::parser::OrgSource;

mod exiting;
mod list;
mod parser_context;
mod parser_with_context;

type RefContext<'r, 's> = &'r Context<'r, 's>;
trait ContextMatcher =
    for<'r, 's> Fn(RefContext<'r, 's>, OrgSource<'s>) -> Res<OrgSource<'s>, OrgSource<'s>>;
type DynContextMatcher<'c> = dyn ContextMatcher + 'c;
trait Matcher = for<'s> Fn(OrgSource<'s>) -> Res<OrgSource<'s>, OrgSource<'s>>;
type DynMatcher<'c> = dyn Matcher + 'c;
